unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, NMUDP, ExtCtrls;

type
  TForm1 = class(TForm)
    NMUDP1: TNMUDP;
    Memo2: TMemo;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    CheckBox1: TCheckBox;
    Label8: TLabel;
    Button3: TButton;
    Timer1: TTimer;
    Memo1: TMemo;
    Memo3: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure NMUDP1BufferInvalid(var handled: Boolean;
      var Buff: array of Char; var length: Integer);
    procedure NMUDP1DataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String; Port: Integer);
    procedure NMUDP1DataSend(Sender: TObject);
    procedure NMUDP1Status(Sender: TComponent; status: String);
    procedure NMUDP1InvalidHost(var handled: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  v: boolean;
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  C: array [0..20000] of char;
  s:string;
  l,local,remote,code,row,cnt: integer;

begin
row:=0;
cnt:=-1;
   repeat
   s:=memo1.Lines.Strings[row];
   row:=row+1;
   for l:= 1 to length(s) do begin
      cnt:=cnt+1;
      c[cnt]:= s[l];
   end;
   cnt:=cnt+1;
   c[cnt]:=chr(13);
   until (row = memo1.Lines.Count) or (cnt>19999);

   NMUDP1.RemoteHost := edit3.text;
   NMUDP1.ReportLevel := Status_Basic;
   Val(Edit4.Text, local, Code);
   if Code <> 0 then
    MessageDlg('Local port not number: ' , mtWarning, [mbOk], 0);
   Val(Edit5.Text, remote, Code);
   if Code <> 0 then
    MessageDlg('Remote port not number: ' , mtWarning, [mbOk], 0);
   NMUDP1.LocalPort := 6668;
   NMUDP1.RemotePort := 6668;
   if code= 0 then begin NMUDP1.SendBuffer(C, cnt+1);
      memo1.Lines.clear;
      end;
end;



procedure TForm1.NMUDP1BufferInvalid(var handled: Boolean;
  var Buff: array of Char; var length: Integer);
begin
   memo2.lines.add('Buffer Invalid: Buffer contains no data');
end;

procedure TForm1.NMUDP1DataReceived(Sender: TComponent;
  NumberBytes: Integer; FromIP: String; Port: Integer);
var
   C: array [0..20000] of char;
   st:string;
  I,l: Integer;
begin
  if NumberBytes <= 20000  then
  begin
    NMUDP1.ReadBuffer(C, I);
    if i>0 then begin
       if checkbox1.Checked then beep;
       Memo2.Lines.Add('Received '+IntToStr(I)+' bytes from '+FromIP+' on port '+IntToStr(Port));
    end else
      Memo2.Lines.Add('An unexpected error occured!');
    for l:=0 to i-1 do begin
    if c[l] <> chr(13) then st:=st+c[l] else begin
                  memo3.Lines.add(st);
                  st:='';
               end;
    end;
    end
  else
    Memo2.Lines.Add(IntToStr(I)+' bytes incoming, buffer too small');

 if memo2.Lines.Count>100 then memo2.lines.Clear;   
end;


procedure TForm1.NMUDP1DataSend(Sender: TObject);
begin
  Memo2.Lines.Add('Data sent');
end;

procedure TForm1.NMUDP1Status(Sender: TComponent; status: String);
begin
    Memo2.Lines.Add(status);
end;

procedure TForm1.NMUDP1InvalidHost(var handled: Boolean);
var
  S: String;

begin
  S := NMUDP1.RemoteHost;
  if InputQuery('Invalid host', 'Specify valid hostname: ', S) then
  begin
    NMUDP1.RemoteHost := S;
    handled := TRUE;
  end;
end;



procedure TForm1.Button2Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Edit4Change(Sender: TObject);
var local, code: integer;
begin
 Val(Edit4.Text, local, Code);
  if Code <> 0 then
    MessageDlg('Local port not number: ' , mtWarning, [mbOk], 0);
end;

procedure TForm1.Edit5Change(Sender: TObject);
var remote,code:integer;
begin
  Val(Edit5.Text, remote, Code);
 if Code <> 0 then
    MessageDlg('Remote port not number: ' , mtWarning, [mbOk], 0);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 v:=not v;
  tag:=0  ;
 if v then button3.Caption:='Test repeat on' else button3.Caption:='Test repeat off';
 if v then timer1.Enabled:=true else timer1.Enabled:= false; 
  
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  C: array [0..20000] of char;
  s:string;
  l,code,local,remote,row,cnt: integer;
  ch: string;
begin
row:=0;
cnt:=-1;
tag:=tag+1;
if tag>9 then tag:=0;
   repeat
   s:=memo1.Lines.Strings[row];
   row:=row+1;
   for l:= 1 to length(s) do begin
      cnt:=cnt+1;
      c[cnt]:= s[l];
   end;
  
   str(tag,ch);
   c[cnt+1]:=ch[1];
   c[cnt+2]:=chr(13);
   cnt:=cnt+2;
   until (row = memo1.Lines.Count) or (cnt>19999);
      NMUDP1.RemoteHost := edit3.text;
   NMUDP1.ReportLevel := Status_Basic;
   Val(Edit4.Text, local, Code);
   Val(Edit5.Text, remote, Code);
   NMUDP1.LocalPort := 6668;
   NMUDP1.RemotePort := 6668;
   if code= 0 then begin NMUDP1.SendBuffer(C, cnt+2);
   end;
end;


end.
